clear all
close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Spectral_information_criterion                                     %%%%
%%% Luca Martino, Roberto San Millán, Eduardo Morgado                  %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
%%% JUST RUN ME !!
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
example=4;
disp('----------------------------------------------------')
%%%%%%%%%%%%%%%%%%%%
switch example
    case 1    
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Clustering
       load Clustering_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp('Clustering Experiment')
     case 2    
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Dimension Reduction
       load Dim_Red_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp('Dimension Experiment')
     case 3
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Polynomial fitting
       load Pol_Fitting_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Polynomial fitting Experiment')
     case 4
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection regression Soundscape Data
       load VarSelection_regresion_SoundscapeData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Variable Selection regression Soundscape Data - Experiment')
     case 5
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection classification Biomedical Data
       load VarSelection_classification_BioData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
       disp('Variable Selection classification Biomedical Data - Experiment')
     case 6
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.1*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        disp(['Artificial Example ',num2str(example)])
     case 7
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.01*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
       disp(['Artificial Example ',num2str(example)])
    otherwise
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.001*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Artificial Example - other')
end
disp('----------------------------------------------------')
%%%%%%%%%%%%%%%%%
V=V-min(V); %%% just a check, without loss of generality
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[Elbow_set,Elbows]=SICmethod_v4(V);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if example==1
    disp('in the clustering case, k=0 represents one cluster...then, the solutions are:')
    disp(Elbows+1)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
plot(0:length(V)-1,V,'LineWidth',2)
hold on
plot(Elbows(end),V(Elbows(end)+1),'ro','MarkerSize',10,'MarkerFaceColor','g')
set(gca,'Fontsize',20)
xlabel('k')
ylabel('V(k)')
legend('V(k)','Elbow')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% examples for changing the parameters:
% % %  paramFun.N=100000;
% % %  paramFun.ell=0.99;
% % %  paramFun.plotyes=0; %%% 0 (no plots) or 1 (to plot)
% % %  [Elbow_set,Elbows]=SICmethod_v4(V,paramFun);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
